<?php

namespace STM\Helpers;

use \Exception;
use STM\Libs\FormProcessor;

/**
 * Test class for ObjectValidator.
 * Generated by PHPUnit on 2011-09-01 at 17:36:45.
 * @group helpers
 */
class ObjectValidatorTest extends \PHPUnit_Framework_TestCase {

    private $bad_values;
    private $bad_instances;
    private $good_instances;

    protected function setUp() {
        $this->bad_values = array(null, false, array(), new Exception());

        $this->bad_instances = array();
        foreach ($this->bad_values as $value) {
            // $values is not class so I cannot set compared objects
            $this->bad_instances[] = new ObjectValidator($value);
        }
        $this->good_instances = array(
            'Exception' => new ObjectValidator('Exception'),
            'stdClass' => new ObjectValidator('stdClass')
        );
    }

    protected function tearDown() {
        
    }

    public function testSet_formProcessor() {
        // after setring it resets FormProcessor
        $fp = new FormProcessor();
        foreach ($this->bad_instances as $instance) {
            $fp->addError('Error...');
            $this->assertFalse($fp->isValid());
            $instance->setFormProcessor($fp);
            $this->assertTrue($fp->isValid());
            $this->assertTrue($instance->isValid());
        }
        // same for good_instances
    }

    public function testgetFormProcessor() {
        foreach ($this->bad_instances as $instance) {
            $this->assertTrue($instance->getFormProcessor() instanceof FormProcessor);

            // if argument is not instance of FormProcessor, then is set new instance of FormProcessor
            foreach ($this->bad_values as $value) {
                $instance->setFormProcessor($value);
                $this->assertTrue($instance->getFormProcessor() instanceof FormProcessor);
            }
        }
        // same for good_instances
    }

    public function testisValid() {
        foreach ($this->bad_instances as $instance) {
            $this->assertTrue($instance->isValid());

            // if argument is not instance of FormProcessor, then is set new instance of FormProcessor
            foreach ($this->bad_values as $value) {
                $instance->setFormProcessor($value);
                $this->assertTrue($instance->isValid());
            }
        }
        // same for good_instances
    }

    // test of set/getComparedObject
    public function testSet_compared_object() {
        foreach ($this->bad_instances as $instance) {
            foreach ($this->bad_values as $value) {
                $instance->setComparedObject($value);
                $this->assertFalse($instance->getComparedObject());
            }
        }

        foreach ($this->good_instances as $className => $instance) {
            $instance->setComparedObject(new $className());
            $this->assertTrue($instance->getComparedObject() instanceof $className);
        }
    }

    public function testResetComparedObject() {
        foreach ($this->good_instances as $className => $instance) {
            $instance->setComparedObject(new $className());
            $instance->resetComparedObject();
            $this->assertFalse($instance->getComparedObject());
        }
    }

    public function testIs_setComparedObject() {
        foreach ($this->bad_instances as $instance) {
            $this->assertFalse($instance->isSetComparedObject());
            foreach ($this->bad_values as $value) {
                $instance->setComparedObject($value);
                $this->assertFalse($instance->isSetComparedObject());
            }
        }

        foreach ($this->good_instances as $className => $instance) {
            $instance->setComparedObject(new $className());
            $this->assertTrue($instance->isSetComparedObject());

            $instance->resetComparedObject();
            $this->assertFalse($instance->isSetComparedObject());
        }
    }

    public function testcheckString() {                
        foreach ($this->bad_instances as $instance) {
            $this->assertTrue($instance->checkString('string', array('min' => 4, 'max' => 10)));
            $this->assertTrue($instance->checkString('string', array('min' => 4, 'max' => 10), 'Field'));
            
            // fail - string length
            $this->assertFalse($instance->checkString('string', array('min' => 8, 'max' => 10), 'Field'));
            $instance->getFormProcessor()->resetErrors();
            
            // fail - same as old
            $this->assertFalse($instance->checkString('string', array('min' => 4, 'max' => 10), 'Field', 'string'));
            $instance->getFormProcessor()->resetErrors();
            
            
            foreach ($this->bad_values as $value) {    
                // fail - invalid values in $string, $range or $error_name
                
                $this->assertFalse($instance->checkString($value, $value, $value, $value));
                $instance->getFormProcessor()->resetErrors();
                
                $this->assertFalse($instance->checkString('string', $value, $value, $value));
                $instance->getFormProcessor()->resetErrors();
                
                $this->assertFalse($instance->checkString('string', array('min' => 5, 'max' => 10), $value, $value));
                $instance->getFormProcessor()->resetErrors();
            }
        }
    }

    public function testCheck_number() {
        foreach ($this->bad_instances as $instance) {
            $this->assertTrue($instance->checkNumber(5, array('min' => 0, 'max' => 10)));
            $this->assertTrue($instance->checkNumber(5, array('min' => 0, 'max' => 10), 'Field'));
            
            // fail - not in range
            $this->assertFalse($instance->checkNumber(5, array('min' => 8, 'max' => 10), 'Field'));
            $instance->getFormProcessor()->resetErrors();
            
            foreach ($this->bad_values as $value) {    
                // fail - invalid values in $number, $range or $error_name
                
                $this->assertFalse($instance->checkNumber($value, $value, $value));
                $instance->getFormProcessor()->resetErrors();
                
                $this->assertFalse($instance->checkNumber(5, $value, $value));
                $instance->getFormProcessor()->resetErrors();
                
                $this->assertFalse($instance->checkNumber(7, array('min' => 5, 'max' => 10), $value));
                $instance->getFormProcessor()->resetErrors();
            }
        }
    }

    public function testCheck_optional_date() {
        foreach ($this->bad_instances as $instance) {
            $this->assertTrue($instance->checkOptionalDate('today.', 'Field'));
            $this->assertTrue($instance->checkOptionalDate('1.1.2011', 'Field'));
            $this->assertTrue($instance->checkOptionalDate('2.2.2002 22:22:22', 'Field'));
            
            foreach ($this->bad_values as $value) {    
                // fail - invalid values in $date or error message
                $this->assertFalse($instance->checkOptionalDate($value, $value));
                $instance->getFormProcessor()->resetErrors();
            }
        }
    }

    public function testCheck_unique_name() {
        $this->markTestIncomplete('
            Same as checkString + I need to know class methods for finding if
            name exists and method to get name of compared object.
            Tests of this method are in TeamValidator, CompetitionValidator, UserValidator
            ');
    }

    public function testCheck_create() {
        foreach ($this->good_instances as $className => $instance) {
            // check create reset compared object
            $instance->setComparedObject(new $className());
            $instance->checkCreate(array('name' => 'dasdas'), array('name'));
            $this->assertFalse($instance->getComparedObject());
            
            // doesn't matter on order
            $this->assertTrue($instance->checkCreate(array('name' => 'dasdas', 'b' => 5), array('name', 'b')));
            $this->assertTrue($instance->checkCreate(array('name' => 'dasdas', 'b' => 5), array('b', 'name')));
            
            // all keys from second array, but first cannot contains some extra items
            $this->assertFalse($instance->checkCreate(array('name' => 'dasdas', 'b' => 5), array('b')));
            
            // first array must contain all keys from second array
            $this->assertFalse($instance->checkCreate(array('name' => 'dasdas', 'bbb' => 5), array('b')));
            $instance->getFormProcessor()->resetErrors();
            
            // values must be arrays (other tests in test of isArrayValid function)
        }
    }

    public function testGet_value_from_compared() {
        foreach ($this->bad_instances as $instance) {
            $this->assertFalse($instance->getValueFromCompared('xxx'));
            foreach ($this->bad_values as $value) {
                $instance->setComparedObject($value);
                $this->assertFalse($instance->getValueFromCompared('xxx'));
                $this->assertFalse($instance->getValueFromCompared($value));
            }
        }

        foreach ($this->good_instances as $className => $instance) {
            $instance->setComparedObject(new $className());

            $class_methods = get_class_methods($className);
            foreach ($class_methods as $method) {
                // $instance->getValueFromCompared($method);
                // cannot test it, I dont know what method will return, but if
                // method has no required parameters then it will work
            }

            $instance->resetComparedObject();
            $this->assertFalse($instance->getValueFromCompared('xxx'));
            foreach ($this->bad_values as $value) {
                $this->assertFalse($instance->getValueFromCompared($value));
            }
        }
    }

}

?>
